//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop

#include "RichEditVScroll.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TRichEditVScroll *)
{
    new TRichEditVScroll(NULL);
}
//---------------------------------------------------------------------------
__fastcall TRichEditVScroll::TRichEditVScroll(TComponent* Owner)
    : TRichEdit(Owner)
{
    m_pSynchro = NULL;
    m_iX = 0;
    m_iY = 0;
}

void __fastcall TRichEditVScroll::WndProc(Messages::TMessage &Message)
{
    TPoint p;
    switch (Message.Msg)
    {
        case WM_SETFOCUS:
        //case WM_KILLFOCUS:
            p = GetCaretPos();
            CaretX = p.x;
            CaretY = p.y;
            break;
        case WM_VSCROLL:
        case WM_HSCROLL:
        case WM_MOUSEWHEEL:
            p = GetCaretPos();
            CaretX = p.x;
            CaretY = p.y;
            if (m_pSynchro &&
                m_pSynchro->Handle != this->Handle &&
                !m_pSynchro->Focused())
            {
                SendMessage(m_pSynchro->Handle, Message.Msg, Message.WParam, Message.LParam);
            }
            break;
        case WM_KEYDOWN:
        case WM_KEYUP:
            switch (Message.WParam)
            {
                case VK_END  :
                case VK_HOME :
                case VK_LEFT :
                case VK_UP   :
                case VK_RIGHT:
                case VK_DOWN :
                case VK_PRIOR:
                case VK_NEXT :
                    TPoint p = GetCaretPos();
                    CaretX = p.x;
                    CaretY = p.y;
                    if (m_pSynchro &&
                        m_pSynchro->Handle != this->Handle &&
                        !m_pSynchro->Focused())
                        {
                            int y0 = SendMessage(this->Handle, EM_GETFIRSTVISIBLELINE, 0, 0);
                            int y1 = SendMessage(m_pSynchro->Handle, EM_GETFIRSTVISIBLELINE, 0, 0);
                            if (y0 != y1) SendMessage(m_pSynchro->Handle, EM_LINESCROLL, 0, y0-y1);
                            if (CaretX != m_pSynchro->CaretX) SendMessage(m_pSynchro->Handle, EM_LINESCROLL, CaretX - m_pSynchro->CaretX, 0);
                        }
                    break;
            }
            break;
    }
    TRichEdit::WndProc(Message);
}
//---------------------------------------------------------------------------
namespace Richeditvscroll
{
    void __fastcall PACKAGE Register()
    {
         TComponentClass classes[1] = {__classid(TRichEditVScroll)};
         RegisterComponents("Olegenty", classes, 0);
    }
}
//---------------------------------------------------------------------------
